Bug 129363 - devel/ace build fails if kernel module aio is loaded
Summary: devel/ace build fails if kernel module aio is loaded
Status: Closed FIXED
Alias: None
Product: Ports & Packages
Classification: Unclassified
Component: Individual Port(s) (show other bugs)
Version: Latest
Hardware: Any Any
: Normal Affects Only Me
Assignee: Dmitry Marakasov
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2008-12-02 06:00 UTC by G. Paul Ziemba
Modified: 2009-03-20 01:10 UTC (History)
0 users

See Also:


Attachments
file.diff (756 bytes, patch)
2008-12-02 06:00 UTC, G. Paul Ziemba
no flags Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description G. Paul Ziemba 2008-12-02 06:00:04 UTC
devel/ace (ace-5.5.2_2) build works OK if aio(4) is not loaded, but if aio kernel module is loaded, build fails when it attempts to compile tests/Proactor_Test.cpp.

This failure occurs because of inconsistency between code in POSIX_CB_Proactor.h (which leaves class ACE_POSIX_CB_Proactor undefined if defined (__FreeBSD__)) and code in Proactor_Test.cpp (which assumes it is defined). There is an identical situation with Proactor_Test_IPV6.cpp as well.

In the default case where kernel module aio(4) is not loaded, the ACE configure script does not detect the presence of aio and therefore leaves ACE_HAS_AIO_CALLS undefined. In this case, the test code in Proactor_Test.cpp and Proactor_Test_IPV6.cpp is not compiled, and there is no build failure.

Fix: The attached patch qualifies the relevant code blocks with "!defined(__FreeBSD__)" to make them consistent with POSIX_CB_Proactor.h.

Patch attached with submission follows:
How-To-Repeat: # kldload aio
# cd /usr/ports/devel/ace
# make clean && make
Comment 1 Edwin Groothuis freebsd_committer 2008-12-02 06:00:14 UTC
Responsible Changed
From-To: freebsd-ports-bugs->sem

Over to maintainer (via the GNATS Auto Assign Tool)
Comment 2 Sergey Matveychuk freebsd_committer 2008-12-22 16:12:42 UTC
Responsible Changed
From-To: sem->freebsd-ports-bugs

Return to the pool
Comment 3 Dmitry Marakasov freebsd_committer 2009-03-20 01:00:40 UTC
Responsible Changed
From-To: freebsd-ports-bugs->amdmi3

I'll take it.
Comment 4 Dmitry Marakasov freebsd_committer 2009-03-20 01:01:55 UTC
State Changed
From-To: open->closed

Committed. Thanks!
Comment 5 dfilter service freebsd_committer 2009-03-20 01:02:00 UTC
amdmi3      2009-03-20 01:01:51 UTC

  FreeBSD ports repository

  Modified files:
    devel/ace            Makefile 
  Added files:
    devel/ace/files      patch-tests 
  Log:
  - Fix build when aio.ko is loaded
  - While here, fix build on CURRENT
  
  PR:             129363
  Submitted by:   "G. Paul Ziemba" <p-fbsd-bugs at ziemba dot us>
  
  Revision  Changes    Path
  1.22      +5 -5      ports/devel/ace/Makefile
  1.1       +25 -0     ports/devel/ace/files/patch-tests (new)
_______________________________________________
cvs-all@freebsd.org mailing list
http://lists.freebsd.org/mailman/listinfo/cvs-all
To unsubscribe, send any mail to "cvs-all-unsubscribe@freebsd.org"